import{s as Rt,n as jt,o as It}from"../chunks/scheduler.b108d059.js";import{S as Vt,i as Wt,g as a,s as i,r as s,A as Bt,h as p,f as l,c as o,j as Zt,u as m,x as c,k as kt,y as Qt,a as n,v as u,d,t as r,w as f}from"../chunks/index.008de539.js";import{C as L}from"../chunks/CodeBlock.3968c746.js";import{H as g}from"../chunks/Heading.88bfeb84.js";function Lt(yt){let $,A,X,F,h,N,w,Y,U,Tt=`We assume the reader has already created a Google Cloud Platform (GCP) user or organisation account and an
associated project.`,D,v,Ct=`We also assume the reader to have the Google Cloud CLI installed. If not please follow the links right after to
<a href="https://cloud.google.com/sdk/docs/install" rel="nofollow">install</a> and <a href="https://cloud.google.com/sdk/docs/initializing" rel="nofollow">setup</a>.`,O,y,q,T,Mt="In order to create your initial TPU instance, you will need to provide some information:",K,C,xt="<li>The zone in GCP you would like to see the instance being deployed (close to the reader for development purpose, close to the end user for production for instance)</li> <li>Which kind of TPU you would like to target</li> <li>Which version of the TPU runtime you want to leverage on the instance</li> <li>Custom instance name to quickly skim and refer back to the instance</li>",tt,M,Pt="Overall the end command looks like this:",et,x,lt,P,nt,b,bt=`In our case we will be deploying a <code>v5litepod-8</code> instance name <code>optimum-tpu-get-started</code>
in the GCP region <code>us-west4-a</code> using the latest <code>v2-alpha-tpuv5-lite</code> runtime version.`,it,_,_t="Of course, feel free to adjust all these parameters to the one that match with your usage and quotas.",ot,z,zt=`Before creating the instance, please make sure to install <code>gcloud alpha component</code> as it is required to be able to
target TPUv5 VMs: <code>gcloud components install alpha</code>`,at,S,pt,J,st,G,mt,H,St="In the example above deploying v5litepod-8 it would be something like:",ut,Z,dt,k,rt,R,ft,j,Jt="If you want to leverage PyTorch/XLA through Optimum-TPU, it should be as simple as",ct,I,$t,V,Gt=`Now you can validate the installation with the following command which should print <code>xla:0</code> as we do have a single
TPU device bound to this instance.`,gt,W,ht,B,wt,Q,Ht="JAX is coming very soon - stay tuned!",Ut,E,vt;return h=new g({props:{title:"Deploying a Google TPU instance on Google Cloud Platform (GCP)",local:"deploying-a-google-tpu-instance-on-google-cloud-platform-gcp",headingTag:"h1"}}),w=new g({props:{title:"Context",local:"context",headingTag:"h2"}}),y=new g({props:{title:"Creating the initial TPUVM on GCP",local:"creating-the-initial-tpuvm-on-gcp",headingTag:"h2"}}),x=new L({props:{code:"Z2Nsb3VkJTIwY29tcHV0ZSUyMHRwdXMlMjB0cHUtdm0lMjBjcmVhdGUlMjAlM0NyZWZfaW5zdGFuY2VfbmFtZSUzRSUyMCU1QyUwQS0tem9uZSUzRCUzQ2RlcGxvaW1lbnRfem9uZSUzRSUyMCU1QyUwQS0tYWNjZWxlcmF0b3ItdHlwZSUzRCUzQ3RhcmdldF90cHVfZ2VuZXJhdGlvbiUzRSUyMCU1QyUwQS0tdmVyc2lvbiUzRCUzQ3J1bnRpbWVfdmVyc2lvbiUzRQ==",highlighted:`gcloud compute tpus tpu-vm create &lt;ref_instance_name&gt; \\
--zone=&lt;deploiment_zone&gt; \\
--accelerator-type=&lt;target_tpu_generation&gt; \\
--version=&lt;runtime_version&gt;`,wrap:!1}}),P=new g({props:{title:"Deploying a TPU v5litepod-8 instance",local:"deploying-a-tpu-v5litepod-8-instance",headingTag:"h3"}}),S=new L({props:{code:"Z2Nsb3VkJTIwYWxwaGElMjBjb21wdXRlJTIwdHB1cyUyMHRwdS12bSUyMGNyZWF0ZSUyMG9wdGltdW0tdHB1LWdldC1zdGFydGVkJTIwJTVDJTBBLS16b25lJTNEdXMtd2VzdDQtYSUyMCU1QyUwQS0tYWNjZWxlcmF0b3ItdHlwZSUzRHY1bGl0ZXBvZC04JTIwJTVDJTBBLS12ZXJzaW9uJTNEdjItYWxwaGEtdHB1djU=",highlighted:`gcloud alpha compute tpus tpu-vm create optimum-tpu-get-started \\
--zone=us-west4-a \\
--accelerator-type=v5litepod-8 \\
--version=v2-alpha-tpuv5`,wrap:!1}}),J=new g({props:{title:"Connecting to the instance",local:"connecting-to-the-instance",headingTag:"h2"}}),G=new L({props:{code:"Z2Nsb3VkJTIwY29tcHV0ZSUyMHRwdXMlMjB0cHUtdm0lMjBzc2glMjAlM0NyZWZfaW5zdGFuY2VfbmFtZSUzRSUyMC0tem9uZSUzRCUzQ2RlcGxvaW1lbnRfem9uZSUzRSUwQSUyNCUyMCUzRQ==",highlighted:`gcloud compute tpus tpu-vm ssh &lt;ref_instance_name&gt; --zone=&lt;deploiment_zone&gt;
$ &gt;`,wrap:!1}}),Z=new L({props:{code:"Z2Nsb3VkJTIwY29tcHV0ZSUyMHRwdXMlMjB0cHUtdm0lMjBzc2glMjBvcHRpbXVtLXRwdS1nZXQtc3RhcnRlZCUyMC0tem9uZSUzRHVzLXdlc3Q0LWElMEElMjQlMjAlM0U=",highlighted:`gcloud compute tpus tpu-vm ssh optimum-tpu-get-started --zone=us-west4-a
$ &gt;`,wrap:!1}}),k=new g({props:{title:"Setting up the instance to run AI workloads on TPUs",local:"setting-up-the-instance-to-run-ai-workloads-on-tpus",headingTag:"h2"}}),R=new g({props:{title:"Optimum-TPU with PyTorch/XLA",local:"optimum-tpu-with-pytorchxla",headingTag:"h3"}}),I=new L({props:{code:"JTI0JTIwcHl0aG9uMyUyMC1tJTIwcGlwJTIwaW5zdGFsbCUyMG9wdGltdW0tdHB1JTBBJTI0JTIwZXhwb3J0JTIwUEpSVF9ERVZJQ0UlM0RUUFU=",highlighted:`$ python3 -m pip install optimum-tpu
$ <span class="hljs-built_in">export</span> PJRT_DEVICE=TPU`,wrap:!1}}),W=new L({props:{code:"JTI0JTIwcHl0aG9uJTIwLWMlMjAlMjJpbXBvcnQlMjB0b3JjaF94bGEuY29yZS54bGFfbW9kZWwlMjBhcyUyMHhtJTNCJTIwcHJpbnQoeG0ueGxhX2RldmljZSgpKSUyMiUwQXhsYSUzQTA=",highlighted:`$ python -c <span class="hljs-string">&quot;import torch_xla.core.xla_model as xm; print(xm.xla_device())&quot;</span>
xla:0`,wrap:!1}}),B=new g({props:{title:"Optimum-TPU with JAX",local:"optimum-tpu-with-jax",headingTag:"h3"}}),{c(){$=a("meta"),A=i(),X=a("p"),F=i(),s(h.$$.fragment),N=i(),s(w.$$.fragment),Y=i(),U=a("p"),U.textContent=Tt,D=i(),v=a("p"),v.innerHTML=Ct,O=i(),s(y.$$.fragment),q=i(),T=a("p"),T.textContent=Mt,K=i(),C=a("ul"),C.innerHTML=xt,tt=i(),M=a("p"),M.textContent=Pt,et=i(),s(x.$$.fragment),lt=i(),s(P.$$.fragment),nt=i(),b=a("p"),b.innerHTML=bt,it=i(),_=a("p"),_.textContent=_t,ot=i(),z=a("p"),z.innerHTML=zt,at=i(),s(S.$$.fragment),pt=i(),s(J.$$.fragment),st=i(),s(G.$$.fragment),mt=i(),H=a("p"),H.textContent=St,ut=i(),s(Z.$$.fragment),dt=i(),s(k.$$.fragment),rt=i(),s(R.$$.fragment),ft=i(),j=a("p"),j.textContent=Jt,ct=i(),s(I.$$.fragment),$t=i(),V=a("p"),V.innerHTML=Gt,gt=i(),s(W.$$.fragment),ht=i(),s(B.$$.fragment),wt=i(),Q=a("p"),Q.textContent=Ht,Ut=i(),E=a("p"),this.h()},l(t){const e=Bt("svelte-u9bgzb",document.head);$=p(e,"META",{name:!0,content:!0}),e.forEach(l),A=o(t),X=p(t,"P",{}),Zt(X).forEach(l),F=o(t),m(h.$$.fragment,t),N=o(t),m(w.$$.fragment,t),Y=o(t),U=p(t,"P",{"data-svelte-h":!0}),c(U)!=="svelte-erf97f"&&(U.textContent=Tt),D=o(t),v=p(t,"P",{"data-svelte-h":!0}),c(v)!=="svelte-264pl4"&&(v.innerHTML=Ct),O=o(t),m(y.$$.fragment,t),q=o(t),T=p(t,"P",{"data-svelte-h":!0}),c(T)!=="svelte-n1fuae"&&(T.textContent=Mt),K=o(t),C=p(t,"UL",{"data-svelte-h":!0}),c(C)!=="svelte-1y7zwvh"&&(C.innerHTML=xt),tt=o(t),M=p(t,"P",{"data-svelte-h":!0}),c(M)!=="svelte-1mb5j9l"&&(M.textContent=Pt),et=o(t),m(x.$$.fragment,t),lt=o(t),m(P.$$.fragment,t),nt=o(t),b=p(t,"P",{"data-svelte-h":!0}),c(b)!=="svelte-m223dm"&&(b.innerHTML=bt),it=o(t),_=p(t,"P",{"data-svelte-h":!0}),c(_)!=="svelte-ipoz1i"&&(_.textContent=_t),ot=o(t),z=p(t,"P",{"data-svelte-h":!0}),c(z)!=="svelte-1un03r3"&&(z.innerHTML=zt),at=o(t),m(S.$$.fragment,t),pt=o(t),m(J.$$.fragment,t),st=o(t),m(G.$$.fragment,t),mt=o(t),H=p(t,"P",{"data-svelte-h":!0}),c(H)!=="svelte-nx4k2f"&&(H.textContent=St),ut=o(t),m(Z.$$.fragment,t),dt=o(t),m(k.$$.fragment,t),rt=o(t),m(R.$$.fragment,t),ft=o(t),j=p(t,"P",{"data-svelte-h":!0}),c(j)!=="svelte-1knmexs"&&(j.textContent=Jt),ct=o(t),m(I.$$.fragment,t),$t=o(t),V=p(t,"P",{"data-svelte-h":!0}),c(V)!=="svelte-5yzmiv"&&(V.innerHTML=Gt),gt=o(t),m(W.$$.fragment,t),ht=o(t),m(B.$$.fragment,t),wt=o(t),Q=p(t,"P",{"data-svelte-h":!0}),c(Q)!=="svelte-1m525yu"&&(Q.textContent=Ht),Ut=o(t),E=p(t,"P",{}),Zt(E).forEach(l),this.h()},h(){kt($,"name","hf:doc:metadata"),kt($,"content",Xt)},m(t,e){Qt(document.head,$),n(t,A,e),n(t,X,e),n(t,F,e),u(h,t,e),n(t,N,e),u(w,t,e),n(t,Y,e),n(t,U,e),n(t,D,e),n(t,v,e),n(t,O,e),u(y,t,e),n(t,q,e),n(t,T,e),n(t,K,e),n(t,C,e),n(t,tt,e),n(t,M,e),n(t,et,e),u(x,t,e),n(t,lt,e),u(P,t,e),n(t,nt,e),n(t,b,e),n(t,it,e),n(t,_,e),n(t,ot,e),n(t,z,e),n(t,at,e),u(S,t,e),n(t,pt,e),u(J,t,e),n(t,st,e),u(G,t,e),n(t,mt,e),n(t,H,e),n(t,ut,e),u(Z,t,e),n(t,dt,e),u(k,t,e),n(t,rt,e),u(R,t,e),n(t,ft,e),n(t,j,e),n(t,ct,e),u(I,t,e),n(t,$t,e),n(t,V,e),n(t,gt,e),u(W,t,e),n(t,ht,e),u(B,t,e),n(t,wt,e),n(t,Q,e),n(t,Ut,e),n(t,E,e),vt=!0},p:jt,i(t){vt||(d(h.$$.fragment,t),d(w.$$.fragment,t),d(y.$$.fragment,t),d(x.$$.fragment,t),d(P.$$.fragment,t),d(S.$$.fragment,t),d(J.$$.fragment,t),d(G.$$.fragment,t),d(Z.$$.fragment,t),d(k.$$.fragment,t),d(R.$$.fragment,t),d(I.$$.fragment,t),d(W.$$.fragment,t),d(B.$$.fragment,t),vt=!0)},o(t){r(h.$$.fragment,t),r(w.$$.fragment,t),r(y.$$.fragment,t),r(x.$$.fragment,t),r(P.$$.fragment,t),r(S.$$.fragment,t),r(J.$$.fragment,t),r(G.$$.fragment,t),r(Z.$$.fragment,t),r(k.$$.fragment,t),r(R.$$.fragment,t),r(I.$$.fragment,t),r(W.$$.fragment,t),r(B.$$.fragment,t),vt=!1},d(t){t&&(l(A),l(X),l(F),l(N),l(Y),l(U),l(D),l(v),l(O),l(q),l(T),l(K),l(C),l(tt),l(M),l(et),l(lt),l(nt),l(b),l(it),l(_),l(ot),l(z),l(at),l(pt),l(st),l(mt),l(H),l(ut),l(dt),l(rt),l(ft),l(j),l(ct),l($t),l(V),l(gt),l(ht),l(wt),l(Q),l(Ut),l(E)),l($),f(h,t),f(w,t),f(y,t),f(x,t),f(P,t),f(S,t),f(J,t),f(G,t),f(Z,t),f(k,t),f(R,t),f(I,t),f(W,t),f(B,t)}}}const Xt='{"title":"Deploying a Google TPU instance on Google Cloud Platform (GCP)","local":"deploying-a-google-tpu-instance-on-google-cloud-platform-gcp","sections":[{"title":"Context","local":"context","sections":[],"depth":2},{"title":"Creating the initial TPUVM on GCP","local":"creating-the-initial-tpuvm-on-gcp","sections":[{"title":"Deploying a TPU v5litepod-8 instance","local":"deploying-a-tpu-v5litepod-8-instance","sections":[],"depth":3}],"depth":2},{"title":"Connecting to the instance","local":"connecting-to-the-instance","sections":[],"depth":2},{"title":"Setting up the instance to run AI workloads on TPUs","local":"setting-up-the-instance-to-run-ai-workloads-on-tpus","sections":[{"title":"Optimum-TPU with PyTorch/XLA","local":"optimum-tpu-with-pytorchxla","sections":[],"depth":3},{"title":"Optimum-TPU with JAX","local":"optimum-tpu-with-jax","sections":[],"depth":3}],"depth":2}],"depth":1}';function Et(yt){return It(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Dt extends Vt{constructor($){super(),Wt(this,$,Et,Lt,Rt,{})}}export{Dt as component};
